package jumpstart.web.components.previews;

import jumpstart.web.annotation.ProtectedPage;
import jumpstart.web.commons.Menu;
import jumpstart.web.commons.MenuOption;

import org.apache.tapestry5.annotations.Parameter;
import org.apache.tapestry5.annotations.Property;

@ProtectedPage
public class Layout1 {
	private static final String CHOSEN_OPTION_CSS_CLASS = "chosenOption";

	// Parameters

	@Parameter
	@Property
	@SuppressWarnings("unused")
	private String title;

	@Parameter
	@Property
	private String chosenOption;

	// Screen fields

	private Menu menu;

	@Property
	private MenuOption menuOption;

	// The code

	public Menu getMenu() {

		if (menu == null) {
			menu = new Menu();
			menu.add(new MenuOption("Hello World", "previews/withlayout/HelloWorld"));
			menu.add(new MenuOption("Filter CRUD", "previews/withlayout/filtercrud/Persons"));
			menu.add(new MenuOption("Graceful AJAX Filter CRUD", "previews/withlayout/gracefulajaxfiltercrud/Persons"));
		}

		return menu;
	}

	public String getMenuOptionCSSClass() {
		return menuOption.getLabel().equals(chosenOption) ? CHOSEN_OPTION_CSS_CLASS : "";
	}

}
