package jumpstart.web.pages.examples.jodatime;

import java.util.Locale;

import javax.ejb.EJB;

import jumpstart.business.domain.examples.DateStuff;
import jumpstart.business.domain.examples.iface.IDateStuffServiceLocal;

import org.apache.tapestry5.annotations.Property;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;
import org.joda.time.format.ISODateTimeFormat;

public class JodaTime1 {

	// Screen fields

	@Property
	private DateStuff dateStuff;

	@Property
	@SuppressWarnings("unused")
	private DateTimeFormatter french;

	@Property
	@SuppressWarnings("unused")
	private DateTimeFormatter ISODate;

	// Generally useful bits and pieces

	@EJB
	private IDateStuffServiceLocal dateStuffService;

	// The code

	void setupRender() {

		// Ask business service to find DateStuff with id = 1.

		dateStuff = dateStuffService.findDateStuff(1L);

		if (dateStuff == null) {
			throw new IllegalStateException("Database data has not been set up!");
		}

		french = DateTimeFormat.fullDate().withLocale(Locale.FRENCH);
		ISODate = ISODateTimeFormat.date();
	}
}
