package jumpstart.web.pages.examples.jodatime;

import javax.ejb.EJB;

import jumpstart.business.domain.examples.DateStuff;
import jumpstart.business.domain.examples.iface.IDateStuffServiceLocal;
import jumpstart.util.ExceptionUtil;

import org.apache.tapestry5.annotations.Component;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.corelib.components.Form;

public class JodaTime2 {

	// The activation context

	private Long dateStuffId;

	// Screen fields

	@Property
	private DateStuff dateStuff;

	// Generally useful bits and pieces

	@EJB
	private IDateStuffServiceLocal dateStuffService;

	@Component(id = "dates")
	private Form form;

	// The code

	Long onPassivate() {
		return dateStuffId;
	}

	void onActivate(Long dateStuffId) {
		this.dateStuffId = dateStuffId;
	}

	// Form bubbles up the PREPARE event during form render and form submission.

	void onPrepare() {
		// Ask business service to find DateStuff
		dateStuff = dateStuffService.findDateStuff(dateStuffId);

		if (dateStuff == null) {
			throw new IllegalStateException("Database data has not been set up!");
		}
	}

	void onValidateFromDates() {
		try {
			dateStuffService.changeDateStuff(dateStuff);
		}
		catch (Exception e) {
			// Display the cause. In a real system we would try harder to get a user-friendly message.
			form.recordError(ExceptionUtil.getRootCauseMessage(e));
		}
	}

	Object onSuccess() {
		return JodaTime1.class;
	}

	public String getDateFieldFormat() {
		return "dd/MM/yyyy";
	}
}
