package jumpstart.web.pages.examples.tables;

import java.util.List;

import javax.ejb.EJB;

import jumpstart.business.domain.examples.Person;
import jumpstart.business.domain.examples.iface.IPersonServiceLocal;

import org.apache.tapestry5.ComponentResources;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.beaneditor.BeanModel;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.services.BeanModelSource;

public class GridModel1 {
	private final int MAX_RESULTS = 30;

	// Screen fields

	@Property
	@SuppressWarnings("unused")
	private List<Person> persons;

	@Property
	@SuppressWarnings("unused")
	private Person person;

	@Property
	static private BeanModel<Person> myModel;

	// Generally useful bits and pieces

	@EJB
	private IPersonServiceLocal personService;

	@Inject
	private BeanModelSource beanModelSource;

	@Inject
	private ComponentResources componentResources;

	// The code

	void setupRender() {

		if (myModel == null) {
			myModel = beanModelSource.createDisplayModel(Person.class, componentResources.getMessages());
			myModel.add("action", null);
			myModel.include("id", "firstName", "lastName", "startDate", "action");
			myModel.get("firstName").sortable(false);
			myModel.get("lastName").label("Surname");
		}

		// Get all persons - ask business service to find them (from the database)
		persons = personService.findPersons(MAX_RESULTS);
	}
}
